.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include comctl32.inc
includelib comctl32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

TreeAddItem proto hTreeView:HANDLE,pText:DWORD,uid:DWORD,hParentItem:HANDLE
TreeGetItemClicked proto hTreeView:HANDLE,pTvItem:DWORD

;**********************************************************************************************************

IDLISTTREE  equ 10001

;**********************************************************************************************************

.data
ClassName   db "Twee",0
AppName     db "Treeview Example",0
TvClass     db "SysTreeView32",0
clicky      db "Clicky!",0

g1          db "Fruit",0
 s11         db "Apple",0
 s12         db "Orange",0
 s13         db "Banana",0
g2          db "Vegetable",0
 s21         db "Carrot",0
 s22         db "Potato",0
g3          db "Animal",0
 s31         db "Cow",0
 s32         db "Chicken",0
 s33         db "Pig",0
 s34         db "Sheep",0

rclkid      db "Right-click: %lu",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hTv         HANDLE      ?
tvi         TV_ITEM     <?>
textBuff    db 256 dup (?)

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET ClassName
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,200,300,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_NOTIFY ---------------------------------------------------------------------------------
    .IF (eax==WM_NOTIFY)
        push edi
        mov edi,lParam
        assume edi:ptr NMHDR
        mov eax,[edi].idFrom
        .IF (eax==IDLISTTREE)   ;is from treeview control
            mov eax,[edi].code
            .IF (eax==NM_DBLCLK)
                invoke TreeGetItemClicked, hTv,ADDR tvi
                .IF (!eax)                                  ;only do something if an actual item was clicked
                    mov eax,[tvi].pszText
                    invoke MessageBox, hwnd,eax,ADDR clicky,MB_OK or MB_ICONINFORMATION
                .ENDIF
            .ELSEIF (eax==NM_RCLICK)
                invoke TreeGetItemClicked, hTv,ADDR tvi
                .IF (!eax)                                  ;only do something if an actual item was clicked
                    mov eax,[tvi].lParam
                    invoke wsprintf, ADDR textBuff,ADDR rclkid,eax
                    invoke MessageBox, hwnd,ADDR textBuff,ADDR clicky,MB_OK or MB_ICONINFORMATION
                .ENDIF
            .ENDIF
        .ENDIF
        pop edi
        assume edi:nothing
;-- WM_SIZE -----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_SIZE)
        mov eax,lParam
        mov edx,eax
        and eax,0ffffh  ;width
        shr edx,16      ;height
        invoke MoveWindow, hTv,0,0,eax,edx,TRUE
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke InitCommonControls
        invoke CreateWindowEx, WS_EX_STATICEDGE,ADDR TvClass,NULL,WS_CHILD or WS_VISIBLE or TVS_LINESATROOT or TVS_HASLINES or TVS_HASBUTTONS or TVS_DISABLEDRAGDROP,0,0,0,0,hwnd,IDLISTTREE,hInstance,NULL
        mov hTv,eax

        push ebx
        invoke TreeAddItem, hTv,ADDR g1,100,TVI_ROOT
        mov ebx,eax
          invoke TreeAddItem, hTv,ADDR s11,101,ebx
          invoke TreeAddItem, hTv,ADDR s12,102,ebx
          invoke TreeAddItem, hTv,ADDR s13,103,ebx
        invoke TreeAddItem, hTv,ADDR g2,200,TVI_ROOT
        mov ebx,eax
          invoke TreeAddItem, hTv,ADDR s21,201,ebx
          invoke TreeAddItem, hTv,ADDR s22,202,ebx
        invoke TreeAddItem, hTv,ADDR g3,300,TVI_ROOT
        mov ebx,eax
          invoke TreeAddItem, hTv,ADDR s31,301,ebx
          invoke TreeAddItem, hTv,ADDR s32,302,ebx
          invoke TreeAddItem, hTv,ADDR s33,303,ebx
          invoke TreeAddItem, hTv,ADDR s34,304,ebx
        pop ebx
;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

TreeAddItem proc hTreeView:HANDLE,pText:DWORD,uid:DWORD,hParentItem:HANDLE
    LOCAL is:TV_INSERTSTRUCT
    push esi
    lea esi,[is]
    assume esi:PTR TV_INSERTSTRUCT
    mov eax,hParentItem
    mov [esi].hParent,eax
    mov [esi].hInsertAfter,TVI_LAST
    mov [esi].item.imask,TVIF_TEXT or TVIF_PARAM
    mov eax,pText
    mov [esi].item.pszText,eax
    mov eax,uid
    mov [esi].item.lParam,eax   ;some id associated with the item
    invoke SendMessage, hTv,TVM_INSERTITEM,NULL,esi
    pop esi
    assume esi:nothing
    ;return value is the handle of the item added, or null if failure
    ret
TreeAddItem endp

TreeGetItemClicked proc hTreeView:HANDLE,pTvItem:DWORD
    LOCAL hti:TV_HITTESTINFO
    push esi
    lea esi,[hti]
    assume esi:ptr TV_HITTESTINFO
    invoke GetCursorPos, ADDR [esi].pt
    invoke ScreenToClient, hTreeView,ADDR [esi].pt
    invoke SendMessage, hTreeView,TVM_HITTEST,NULL,esi
    mov eax,[esi].hItem
    or eax,eax
    jz @fail
    mov esi,pTvItem
    assume esi:ptr TV_ITEM
    mov [esi].hItem,eax                         ;specify which item to get (in this case, the one clicked)
    mov [esi].imask,TVIF_TEXT or TVIF_CHILDREN or TVIF_STATE or TVIF_PARAM      ;get info we're interested in (everything!)
    mov [esi].pszText,OFFSET textBuff           ;need somewhere to store the text
    mov [esi].cchTextMax,SIZEOF textBuff
    invoke SendMessage, hTreeView,TVM_GETITEM,0,esi
    xor eax,eax
    jmp @out
  @fail:
    mov eax,-1          ;user clicked on the treeview control, but not on any actual item
  @out:
    pop esi
    assume esi:nothing
    ret
TreeGetItemClicked endp

end start
